<?php

namespace Dao;
use Conn\MySqlConnect;

/**
 * Description of NoticiasComentarios
 *
 * @author Délio
 */
class NoticiasComentarios {
    
    public $id;
    public $fk_id_noticia;
    public $nome;
    public $email;
    public $telefone;
    public $comentario;
    public $data_cadastro;
    public $data_alteracao;
    public $usuario_alterou;
    public $status;
    public $situacao;

    function __construct($res = null) {
        $this->id = (int) 0;
        $this->fk_id_noticia = (int) 0;
        $this->nome = (string) '';
        $this->email = (string) '';
        $this->telefone = (string) '';
        $this->comentario = (string) '';
        $this->data_cadastro = (string) date('Y-m-d H:i:s');
        $this->data_alteracao = (string) date('Y-m-d H:i:s');
        $this->usuario_alterou = (int) 0;
        $this->status = (string) 'A';
        $this->situacao = (string) 'N';
        $this->fill($res);
    }
    
    private function fill($res) {
        if ($res != null && $res instanceof \stdClass) {
            $this->id = (int) (isset($res->id) ? $res->id : 0);
            $this->fk_id_noticia = (int) (isset($res->fk_id_noticia) ? $res->fk_id_noticia : 0);
            $this->nome = (string) (isset($res->nome) ? $res->nome : '');
            $this->email = (string) (isset($res->email) ? $res->email : '');
            $this->telefone = (string) (isset($res->telefone) ? $res->telefone : '');
            $this->comentario = (string) (isset($res->comentario) ? $res->comentario : '');
            $this->data_cadastro = (string) (isset($res->data_cadastro) ? $res->data_cadastro : null);
            $this->data_alteracao = (string) (isset($res->data_alteracao) ? $res->data_alteracao : null);
            $this->usuario_alterou = (int) (isset($res->usuario_alterou) ? $res->usuario_alterou : 0);
            $this->status = (string) (isset($res->status) ? $res->status : 'A');
            $this->situacao = (string) (isset($res->situacao) ? $res->situacao : 'N');
        }
    }

    private function inserir(MySqlConnect $conecta) {
        $sql = $conecta->prepare("INSERT INTO noticias_comentarios (fk_id_noticia, nome, email, telefone, comentario, data_cadastro, status, situacao) VALUES ("
                . "?, ?, ?, ?, ?, ?, ?, ?)") or die($conecta->error);
        $sql->bind_param("isssssss", $this->fk_id_noticia, $this->nome, $this->email, $this->telefone, $this->comentario, $this->data_cadastro, $this->status, 
                $this->situacao);
        if ($sql->execute())
            return json_encode(['data' => 'Success', 'message' => 'Comentário inserido com sucesso!', 'id' => $sql->insert_id]);
        return json_encode(['data' => 'Error', 'message' => $sql->error, 'id' => 0]);
    }
    
    private function editar(MySqlConnect $conecta) {
        $sql = $conecta->prepare("UPDATE noticias_comentarios SET nome = ?, email = ?, telefone = ?, comentario = ?, data_alteracao = ?, usuario_alterou = ?, "
                . "WHERE id = ?") or die($conecta->error);
        $sql->bind_param("sssssii", $this->nome, $this->email, $this->telefone, $this->comentario, $this->data_alteracao, $this->usuario_alterou, $this->id);
        if ($sql->execute())
            return json_encode(['data' => 'Success', 'message' => 'Comentário atualizado com sucesso!', 'id' => $this->id]);
        return json_encode(['data' => 'Error', 'message' => $sql->error, 'id' => $this->id]);
    }
    
    function salvar(MySqlConnect $conecta) {
        if ($this->id == 0)
            return $this->inserir($conecta);
        return $this->editar($conecta);
    }
    
    function excluir(MySqlConnect $conecta) {
        $sql = $conecta->prepare("UPDATE noticias_comentarios SET data_alteracao = ?, usuario_alterou = ?, status = ? WHERE id = ?") or die($conecta->error);
        $sql->bind_param("sisi", $this->data_alteracao, $this->usuario_alterou, $this->status, $this->id);
        if ($sql->execute())
            return json_encode(['data' => 'Success', 'message' => 'Comentário excluido com sucesso!', 'id' => $this->id]);
        return json_encode(['data' => 'Error', 'message' => $sql->error, 'id' => $this->id]);
    }
    
    function getLista(MySqlConnect $conecta, $where = '') {
        $lst_comentarios = [];
        $sql = $conecta->query("SELECT * FROM noticias_comentarios WHERE status = 'A' $where") or die($conecta->error);
        while ($res = $sql->fetch_object())
            $lst_comentarios[] = new NoticiasComentarios($res);
        return $lst_comentarios;
    }
    
    function getComentarioPorId(MySqlConnect $conecta, $id) {
        $sql = $conecta->query("SELECT * FROM noticias_comentarios WHERE id = '$id' AND status = 'A'") or die($conecta->error);
        if ($sql->num_rows > 0) {
            $res = $sql->fetch_object();
            $this->fill($res);
        }
    }
}